/*$Id: macro-net.cc,v 1.52 2003/02/16 11:25:10 al Exp $ -*- C++ -*-
 */
#include "macro.h"
/*--------------------------------------------------------------------------*/
namespace Netlist {
/*--------------------------------------------------------------------------*/
static void make_macro_body(std::ostream& out, const Macro_Body& m)
{
  {for (Macro_Body::const_iterator i = m.begin(); i != m.end(); ++i) {
    // each **i is an element in the macro
    assert(*i);
    assert(!dynamic_cast<const Inherit*>(*i));
    // we are working with a "reduced" copy, so the following stmt
    // prints it in a reduced form, ready to simulate. (supposedly)
    out << '.' << **i;
  }}
}
/*--------------------------------------------------------------------------*/
void make_macro(std::ostream& out, const Macro* m,
		const std::string& subckt_name, const std::string&)
{
  assert(m);
  out << ".subckt " << subckt_name << " ( ";
  {for (Port_List::const_iterator
	 i = m->ports().begin();  i != m->ports().end();  ++i) {
    out << **i << ' ';
  }}
  out << ")\n";
  make_macro_body(out, m->body());
  out << ".ends " << subckt_name <<"\n\n";
}
/*--------------------------------------------------------------------------*/
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
